<html>
  <head>
    <title>Nonogramme Vue.js</title>
    <style>
      table {
        border: 1px solid gray;
        border-collapse: collapse;
      }
      tr, td {
        height: 20px;
      }
      td {
        width: 20px;
        border: 1px solid gray;
      }
      td:hover {
        background-color: red;
      }
      .selected {
        background-color: blue;
      }
    </style>
  </head>
  <body>
    <div id='n7-nonogramme-vuejs'>

      <div>
        Configuration du Nonogramme
        <br/>

        <label>Nombre de colonnes</label>
        <input v-model.number="numberCells" type="number" />
        
        <label>Nombre de lignes</label>
        <input v-model.number="numberRows" type="number" />
        
        <button @click="createCellsValuesArray">Créer le nonogramme</button>
      </div>
      
      <table>
        <tr
          v-for="(currentRow, rowIndex) in cellsValues"
          :key="'r' + rowIndex"
        >
          <td
            v-for="(isCurrentCellSelected, cellIndex) in currentRow"
            :key="'r' + rowIndex + 'c' + cellIndex"
            :class="isCurrentCellSelected ? 'selected' : ''"
            @click="currentRow[cellIndex] = !currentRow[cellIndex]"
          />
        </tr>
      </table>

      <div>
        <label>Titre</label>
        <input v-model="title" type="text" />
        <br/>

        <button @click="exportPicross">
          Exporter le nonogramme
        </button>
      </div>
    </div>
    <script src="https://unpkg.com/vue@next"></script>
    <script type="text/javascript">
      const app = Vue.createApp({
        data () {
          return {
            title: '',
            numberRows: 6,
            numberCells: 6,
            cellsValues: null
          }
        },
        methods: {
          createCellsValuesArray() {
            const cellsValues = []
            for (let i = 0; i < this.numberRows; i++) {
              const currentRowCellsValues = new Array(this.numberCells).fill(false, 0, this.numberCells)
              cellsValues.push(currentRowCellsValues)
            }
            this.cellsValues = cellsValues
          },
          exportPicross() {
            const nonogram = {
              title: this.title,
              data: JSON.parse(JSON.stringify(this.cellsValues))
            }
            console.log(nonogram)
          }
        },
        created () {
          this.numberCells = 10
          this.createCellsValuesArray()
        }
      }).mount('#n7-nonogramme-vuejs')
    </script>
  </body>
</html>
